/* Contributed by Nicola Pero <nicola.pero@meta-innovation.com>, October 2010.  */
/* { dg-do run } */
/* { dg-xfail-run-if "Needs OBJC2 ABI" { *-*-darwin* && { lp64 && { ! objc2 } } } { "-fnext-runtime" } { "" } } */

/* Test that properties are found even if implemented in superclasses.  */

#include <stdlib.h>
#include <objc/objc.h>
#include <objc/runtime.h>

@interface MyRootClass
{
  Class isa;
  int a;
}
/* Use the simplest synthesized accessor (assign, nonatomic) as we are
   not testing the synthesized accessors in this test, just the
   property syntax.  */
@property (nonatomic) int a;
+ (id) initialize;
+ (id) alloc;
- (id) init;
@end

@implementation MyRootClass
+ (id) initialize { return self; }
+ (id) alloc { return class_createInstance (self, 0); }
- (id) init { return self; }
@synthesize a;
@end

@interface MySubClass : MyRootClass
@end

@implementation MySubClass
@end

int main (void)
{
  MySubClass *object = [[MySubClass alloc] init];

  object.a = 40;
  if (object.a != 40)
    abort ();

  return 0;
}
